﻿var OAAS_CONTROLLER = (function (my, Backbone, OAAS_VIEW, OAAS_MODEL, _, $) {
    my.JobPageController = function () {
        this.create = function () {
            var self = this;
            var jobList = new OAAS_MODEL.JobList();
            var jobOverview = new OAAS_VIEW.JobOverView({ collection: jobList, el: $('#jobOverview') });

            var listener = {};
            // add listener capabilities to instance
            _.extend(listener, Backbone.Events);

            listener.listenTo(jobList, 'updated', function (evt) {
                // refresh overview
                jobOverview.render();
            });

            listener.listenTo(jobOverview, 'jobSelected', function (jobId) {
                var runList = new OAAS_MODEL.RunList({ jobId: jobId });
                var lv = new OAAS_VIEW.LoadingView({ el: $('#jobDetails'), model: 'Loading results of job...' });
                lv.render();
                runList.fetch({ cache: false, success: function () {
                    $('#jobDetails').empty();
                    var div = $('<div/>').appendTo($('#jobDetails'));
                    var rv = new OAAS_VIEW.ResultView({ model: runList, el: div });
                    rv.render();
                    var av = new OAAS_VIEW.AccordionView({ el: div });
                    av.render();
                }
                });
            });

            jobList.poll();
        }
    }
    return my;
} (OAAS_CONTROLLER || {}, Backbone, OAAS_VIEW, OAAS_MODEL, _, $));